from datetime import datetime
from multiprocessing import Queue


class LogCat(object):
    def __init__(self, log_queue: Queue, category: str):
        self.queue = log_queue

        self.category = category

    def _write(self, level: str, function: str, message: str) -> None:
        time = datetime.now().strftime("%Y-%m-%dT%H:%M:%S")
        self.queue.put(f"{level} | {time} - {self.category.upper()}.{function.upper()}: {message}")

    def info(self, function: str, message: str) -> None:
        self._write("INFO", function, message)

    def warning(self, function: str, message: str) -> None:
        self._write("WARN", function, message)

    def error(self, function: str, message: str) -> None:
        self._write("ERR ", function, message)
